Bug 45674

Summary: Allow to change error code returned by "Require ldap-filter"
Product: Apache httpd-2 Reporter: Alexandra Kossovsky <Alexandra.Kossovsky>
Component: mod_authz_ldapAssignee: Apache HTTPD Bugs Mailing List <bugs>
Status: RESOLVED LATER    
Severity: enhancement Keywords: FixedInTrunk, MassUpdate
Priority: P2    
Version: 2.2.9   
Target Milestone: ---   
Hardware: PC   
OS: Linux   
Attachments: AuthzLDAPUnauthorized directive may be set to 401 or 403

Description Alexandra Kossovsky 2008-08-22 06:57:05 UTC
Created attachment 22474 [details]
AuthzLDAPUnauthorized directive may be set to 401 or 403

I have a configuration where different parts of website are available to different people. Something like:
<VirtualHost *:443>
AuthType Kerberos
  <Location /xxx>
    Require ldap-filter uid=*
  </Location>
  <Location /yyy>
    Require ldap-filter &(o=something)(zz=value)
  </Location>
</VirtualHost>

When user fails to pass through "require ldap-filter" directive when accessing /yyy directory, he gets error 401.  In many browsers, it means that he is re-asked to type his name/password, even if he decides to go back to /xxx directory. So, I'd like mod_authz_ldap to return 403 instead of 401 in such cases.

There already was similar bug 40721 (I completely agree with you that 401 MUST be the default error code), but I propose to make things more flexible.

The attached patch adds AuthzLDAPUnauthorized directive, which is 401 by default, but may be set to 403 by user.

If you'd like it to have boolean switch (to avoid user setting AuthzLDAPUnauthorized to 200), feel free to ask me to rework my patch.
Comment 1 Eric Covener 2014-01-19 20:41:59 UTC
Fixed in 2.4 and later with AuthzSendForbiddenOnFailure
Comment 2 William A. Rowe Jr. 2018-11-07 21:08:20 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.